(**************************************************************************


:Program.       TestOpenClose.mod

:Contents.      Testet die Fhigkeiten von OpenClose

:Usage          starten...


:Copyright.      1991 by

:Author.        Thomas Ansorge

:Address.       Dinkelackerring 55, W-6730 Neustadt, Deutschland


:Language.      Modula-2

:Translator.    M2Amiga V4.0 (deutsch)


:Imports.       OpenClose


:Version.       1.0 vom 07.12.1991

:History.       1.0 vom 07.12.1991


**************************************************************************)


MODULE TestOpenClose;

FROM DosD IMPORT FileHandlePtr, readOnly;

FROM DosL IMPORT Delay;

FROM ExecD IMPORT MsgPortPtr;

FROM GraphicsD IMPORT FontFlagSet, FontStyleSet, TextAttr, TextFontPtr,
   ViewModes, ViewModeSet;

FROM IntuitionD IMPORT customScreen, IDCMPFlagSet, NewScreen, NewWindow,
   ScreenFlags, ScreenFlagSet, ScreenPtr, WindowFlags, WindowFlagSet,
   WindowPtr;

FROM OpenClose IMPORT Close, CloseFont, CloseScreen, CloseWindow,
   CreatePort, DebugMode, DeletePort, ErrorHandling, ErrorHandlingType,
   Open, OpenFont, OpenScreen, OpenWindow;

FROM SYSTEM IMPORT ADR;

VAR File1,
    File2: FileHandlePtr;
    Port1,
    Port2 : MsgPortPtr;
    NFenster: NewWindow;
    NScreen : NewScreen;
    Fenster1,
    Fenster2 : WindowPtr;
    Screen1,
    Screen2  : ScreenPtr;
    Attr1,
    Attr2     : TextAttr;
    Font1,
    Font2     : TextFontPtr;

BEGIN

DebugMode := TRUE;

ErrorHandling := ErrorNothing;

File1 := Open (ADR ("RAM DISK:bin.info"), readOnly);
File2 := Open (ADR ("RAM DISK:obj.info"), readOnly);

ErrorHandling := ErrorBreakPoint;

Port1 := CreatePort (ADR ("Mein Port 1"), 0);
Port2 := CreatePort (ADR ("Mein Port 2"), 0);

WITH Attr1 DO
   name := ADR ("topaz.font");
   ySize := 8;
   flags := FontFlagSet {};
   style := FontStyleSet {};
END;

WITH Attr2 DO
   name := ADR ("topaz.font");
   ySize := 9;
   flags := FontFlagSet {};
   style := FontStyleSet {};
END;

Font1 := OpenFont (ADR (Attr1));
Font2 := OpenFont (ADR (Attr2));

WITH NScreen DO
   leftEdge := 0;
   topEdge := 0;
   width := 640;
   height := 200;
   depth := 1;
   detailPen := 1;
   blockPen := 0;
   viewModes := ViewModeSet {hires};
   type := customScreen;
   font := ADR (Attr2);
   defaultTitle := ADR ("Screen1");
   gadgets := NIL;
   customBitMap := NIL;
END;

Screen1 := OpenScreen (NScreen);

NScreen.detailPen := 0;
NScreen.blockPen := 1;

Screen2 := OpenScreen (NScreen);

WITH NFenster DO
   leftEdge := 0;
   topEdge := 12;
   width := 200;
   height := 100;
   detailPen := 1;
   blockPen := 0;
   idcmpFlags := IDCMPFlagSet {};
   flags := WindowFlagSet {};
   firstGadget := NIL;
   checkMark := NIL;
   title := ADR ("Fenster 1");
   screen := Screen1;
   bitMap := NIL;
   minWidth := width;
   minHeight := height;
   maxWidth := width;
   maxHeight := height;
   type := customScreen;
END;

Fenster1 := OpenWindow (NFenster);

NFenster.topEdge := 50;
NFenster.title := ADR ("Fenster 2");

Fenster2 := OpenWindow (NFenster);

Delay (500);

CLOSE;

CloseWindow (Fenster2);
CloseWindow (Fenster2);
CloseScreen (Screen2);
CloseScreen (Screen2);
CloseScreen (Screen1);
CloseScreen (Screen1);
CloseFont (Font1);
CloseFont (Font1);
DeletePort (Port2);
DeletePort (Port2);
Close (File2);
Close (File2);

Delay (500);

END TestOpenClose.