(* ------------------------------------------------------------------------
  :Program.       ObSupTest
  :Author.        Kai Bolay [kai]
  :Address.       Snail-Mail:              E-Mail:
  :Address.       Hoffmannstrae 168       UUCP: kai@amokle.adsp.sub.org
  :Address.       D-7250 Leonberg 1        FIDO: 2:247/706.3
  :History.       v1.0 [kai] 16-Jun-92
  :Copyright.      1992 by Kai Bolay
  :Language.      Oberon
  :Translator.    AMIGA OBERON v2.25d
------------------------------------------------------------------------ *)
MODULE ObSupTest;
                   
IMPORT
  io, a: Arguments, os: OberonSupport, e: Exec;

VAR
  String: ARRAY 100 OF CHAR;
  num: INTEGER;
  StrPtr: e.STRPTR;
  Errs: os.ErrorHeaderPtr;

BEGIN
  IF a.NumArgs() # 1 THEN
    io.WriteString ("Usage: ObSupTest ERRORFILE/A\n");
    HALT (20);
  END;
  a.GetArg (1, String);
  Errs := os.ReadErrorFile (String);
  IF Errs = NIL THEN
    io.WriteString ("Cannot read ErrorFile!\n");
    HALT (20);
  END;
  io.WriteString ("NumErrors: "); io.WriteInt (Errs.numErrors, 4);
  io.WriteLn;
  num := 0;
  WHILE num < Errs.numErrors DO
    io.WriteString ("Error #"); io.WriteInt (Errs.error[num].num, 4);
    io.WriteString (": Line"); io.WriteInt (Errs.error[num].line, 4);
    io.WriteString (", Column"); io.WriteInt (Errs.error[num].column, 4);
    io.WriteString (", Text: '");
    StrPtr := os.GetErrorText (Errs.error[num].num);
    IF StrPtr # NIL THEN
      COPY (StrPtr^, String); (* bacause StrPtr can be odd! *)
    ELSE
      String := "*** unknown ***";
    END;
    io.WriteString (String); io.WriteString ("'\n");
    INC (num);
  END; (* WHILE *)
CLOSE
  IF Errs # NIL THEN os.FreeErrorFile (Errs); Errs := NIL END;
END ObSupTest.
