(**************************************************************************

:Program.       IsResident.mod

:Contents.      stellt innerhalb einer Skript- (ARexx-) Datei fest, ob ein
:Contents.      bestimmtes Programm schon resident geladen wurde oder nicht

:Usage.         IsResident <Programmname>


:Copyright.     Public Domain

:Author.        Thomas Ansorge

:Address.       Dinkelackerring 55, W-6730 Neustadt, Deutschland


:Language.      Modula-2

:Translator.    M2Amiga V4.0 (deutsch)


:Imports.       Resident [Thomas Ansorge]


:Version.       1.0 vom 30. April 1992

:History.       1.0 vom 30. April 1992


**************************************************************************)


MODULE IsResident;

FROM Arguments IMPORT GetArg, NumArgs;

FROM Arts IMPORT returnVal;

FROM DosD IMPORT FileHandlePtr, ResidentSegmentPtr;

FROM DosL IMPORT Output, Write;

FROM Resident IMPORT cliStarted, FindResident;

FROM String IMPORT StrToBStr;

FROM SYSTEM IMPORT ADR, CAST;

(* --------------------------------------------------------------------- *)

CONST IRText = "\e[33mIsResident\e[31m";

      CopyrightText = "\n " + IRText + "  1992 Thomas Ansorge\n\o";
      UsageText     = "\n Usage: " + IRText + " <programname>\n\o";

      Out1Text = "\n " + IRText + " searches the list of all resident loaded\n\o";
      Out2Text = " programs for <programname> and returns 0 if <programname>\n\o";
      Out3Text = " was found in the list or 5 (WARN) if not.\n\n\o";

      Found1Text = " " + IRText + ": found \"";
      Found2Text = "\"!\n\o";

      NotFound1Text = " " + IRText + ": could not find \"";

TYPE String = ARRAY [0..255] OF CHAR;

VAR Anzahl      : LONGINT;
    Laenge      : INTEGER;
    OutPut      : FileHandlePtr;
    Programm    : ResidentSegmentPtr;
    Programmname: String;

(* --------------------------------------------------------------------- *)

PROCEDURE CopyBStr (from  : ARRAY OF CHAR;
                    VAR to: ARRAY OF CHAR);

   VAR i: SHORTCARD;

   (* ------------------------------------------------------------------ *)

   BEGIN (* Prozedur CopyBStr *)

   FOR i := 0 TO CAST (SHORTCARD, from [0]) DO
      to [i] := from [i];
   END (* FOR i *);
END CopyBStr (* Prozedur *);

(* --------------------------------------------------------------------- *)
(* --------------------------------------------------------------------- *)

BEGIN (* Hauptprogramm IsResident *)

IF cliStarted THEN
   OutPut := Output ();

   IF OutPut # NIL THEN
      IF NumArgs () = 1 THEN
         GetArg (1, Programmname, Laenge);

         Programm := FindResident (Programmname, FALSE);

         IF Programm # NIL THEN
            CopyBStr (Programm^.name, Programmname);

            Anzahl := Write (OutPut, ADR (Found1Text), SIZE (Found1Text));
            Anzahl := Write (OutPut, ADR (Programmname [1]),
               LONGINT (CAST (SHORTCARD, Programmname [0])));
            Anzahl := Write (OutPut, ADR (Found2Text), SIZE (Found2Text));

            returnVal := 0;

         ELSE (* IF FindResident *);
            StrToBStr (Programmname);

            Anzahl := Write (OutPut, ADR (NotFound1Text), SIZE (NotFound1Text));
            Anzahl := Write (OutPut, ADR (Programmname [1]),
               LONGINT (CAST (SHORTCARD, Programmname [0])));
            Anzahl := Write (OutPut, ADR (Found2Text), SIZE (Found2Text));

            returnVal := 5;
         END (* IF FindResident *);

      ELSE (* NumArgs () # 1 *)
         Anzahl := Write (OutPut, ADR (CopyrightText), SIZE (CopyrightText));
         Anzahl := Write (OutPut, ADR (UsageText), SIZE (UsageText));
         Anzahl := Write (OutPut, ADR (Out1Text), SIZE (Out1Text));
         Anzahl := Write (OutPut, ADR (Out2Text), SIZE (Out2Text));
         Anzahl := Write (OutPut, ADR (Out3Text), SIZE (Out3Text));
      END (* IF NumArgs *);
   END (* IF OutPut *);
END (* IF cliStarted *);

END IsResident (* Modul *).
